use crate::util::pack::unpack_u8;

use super::Packet;

#[derive(Clone)]
pub struct PacketChallenge {
    pub handle:String,
}
impl PacketChallenge {
    pub fn new() -> Self
    {
        Self {
            handle:String::new(),
        }
    }
}
impl Packet for PacketChallenge {
    type Data = Self;

    fn decode(data:&Vec<u8>, index:&mut usize) -> Result<Self::Data, ()>
    {
        let mut result = Self::new();

        let length = unpack_u8(data, index) as usize;
        let mut buffer = vec![0u8; length];
        if data.len() - *index >= length {
            for i in 0..length {
                buffer[i] = data[*index];
                *index += 1;
            }

            result.handle = String::from_utf8(buffer).map_err(|_| ())?;
            Ok(result)
        } else {
            Err(())
        }
    }
}
